"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var JsonRpcClientFactory = require(".");

var WsClientProtocol = require("./protocol/ws");
/**
 * Creates instance of WsClientFactory
 *
 * @extends JsonRpcClientFactory
 */


var WsClientFactory = /*#__PURE__*/function (_JsonRpcClientFactory) {
  _inherits(WsClientFactory, _JsonRpcClientFactory);

  var _super = _createSuper(WsClientFactory);

  /**
   * Additional parameters ontop of those inherited from [JsonRpcClientFactory]{@link JsonRpcClientFactory}
   *
   * @param {object} options Connection options for factory class
   * @param {string} [options.url="ws://127.0.0.1:8100"] Websocket URL to connect to
   * @property {string} url Same as `options.url`
   */
  function WsClientFactory(options) {
    var _this;

    _classCallCheck(this, WsClientFactory);

    _this = _super.call(this, options);

    if (!(_assertThisInitialized(_this) instanceof WsClientFactory)) {
      return _possibleConstructorReturn(_this, new WsClientFactory(options));
    }

    var defaults = {
      url: "ws://127.0.0.1:8100"
    };
    _this.options = _objectSpread(_objectSpread({}, defaults), _this.options || {});
    _this.protocol = WsClientProtocol;
    _this.url = _this.options.url;
    return _this;
  }
  /** @inheritdoc */


  _createClass(WsClientFactory, [{
    key: "buildProtocol",
    value: function buildProtocol() {
      this.pcolInstance = new this.protocol(this, this.options.version, this.options.delimiter);
    }
    /**
     * Calls .end() on the protocol instance
     *
     * @param {number} code Status code for the close event. https://developer.mozilla.org/en-US/docs/Web/API/CloseEvent/code
     * @param {string} reason Reason the connection was closed.
     */

  }, {
    key: "end",
    value: function end(code, reason) {
      this.pcolInstance.end(code, reason);
    }
    /** @inheritdoc */

  }, {
    key: "subscribe",
    value: function subscribe(method, cb) {
      this.on(method, cb);
    }
    /** @inheritdoc */

  }, {
    key: "unsubscribe",
    value: function unsubscribe(method, cb) {
      this.removeListener(method, cb);
    }
    /** @inheritdoc */

  }, {
    key: "unsubscribeAll",
    value: function unsubscribeAll(method) {
      this.removeAllListeners([method]);
    }
  }]);

  return WsClientFactory;
}(JsonRpcClientFactory);

module.exports = WsClientFactory;