"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var http = require("http");

var https = require("https");

var JsonRpcServerFactory = require(".");

var HttpServerProtocol = require("./protocol/http");
/**
 * Creates instance of HttpServerFactory
 * @extends JsonRpcServerFactory
 */


var HttpServerFactory = /*#__PURE__*/function (_JsonRpcServerFactory) {
  _inherits(HttpServerFactory, _JsonRpcServerFactory);

  var _super = _createSuper(HttpServerFactory);

  /**
   *
   * In addition to the params and properties for [JsonRpcServerFactory]{@link JsonRpcServerFactory}
   * the WsServerProtocol has the following properties:
   *
   * @property {'http'|'https'} scheme The scheme to allow connections with
   * @property {object} sslOptions Any of the ssl options for the http server according to https://nodejs.org/api/tls.html#tls_tls_createsecurecontext_options
   */
  function HttpServerFactory(options) {
    var _this;

    _classCallCheck(this, HttpServerFactory);

    _this = _super.call(this, options);
    _this.scheme = _this.options.scheme || "http";
    _this.sslOptions = _this.options.ssl;
    _this.protocol = HttpServerProtocol;
    _this.pendingRequests = [];
    return _this;
  }
  /** @inheritdoc */


  _createClass(HttpServerFactory, [{
    key: "setServer",
    value: function setServer() {
      if (this.scheme === "http") {
        this.server = new http.Server();
      } else if (this.scheme === "https") {
        this.server = new https.Server(_objectSpread({}, this.sslOptions));
      } else {
        throw Error("Invalid scheme");
      }
    }
    /** @inheritdoc */

  }, {
    key: "buildProtocol",
    value: function buildProtocol() {
      var _this2 = this;

      this.server.on("connection", function (client) {
        _this2.clientConnected(client);

        _this2.clients.push(client);

        client.on("close", function () {
          _this2.clientDisconnected(client);
        }); // maybe need .on('end') event listener?
      });
      this.server.on("request", function (request, response) {
        var pcol = new _this2.protocol(_this2, request, response, _this2.options.version, _this2.options.delimiter);
        pcol.clientConnected();

        _this2.pendingRequests.push(pcol);
      });
    }
    /**
     * Called when the server receives a `connection` event.
     *
     * @param {net.Socket} client Instance of `net.Socket`
     * @returns {net.Socket} Returns an instance of `net.Socket`
     */

  }, {
    key: "clientConnected",
    value: function clientConnected(client) {
      return client;
    }
  }]);

  return HttpServerFactory;
}(JsonRpcServerFactory);

module.exports = HttpServerFactory;